package com.dbxml.db.enterprise.jsp;

/*
 * dbXML - Native XML Database
 * Copyright (C) 1999-2004  The dbXML Group, L.L.C.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * $Id: GetDocumentTagInfo.java,v 1.2 2004/02/12 00:17:57 bradford Exp $
 */

import javax.servlet.jsp.tagext.TagData;
import javax.servlet.jsp.tagext.TagExtraInfo;
import javax.servlet.jsp.tagext.VariableInfo;

import org.w3c.dom.Document;

/**
 * GetDocumentTagInfo
 */

public final class GetDocumentTagInfo extends TagExtraInfo {
   private static final String STRING_CLASS = String.class.getName();
   private static final String DOCUMENT_CLASS = Document.class.getName();

   public VariableInfo[] getVariableInfo(TagData data) {
      if ( data.getAttribute(GetDocumentTag.NAME) != null ) {
         VariableInfo[] vars = new VariableInfo[1];
         if ( data.getAttributeString(GetDocumentTag.TEXT).equalsIgnoreCase("TRUE") )
            vars[0] = new VariableInfo(data.getAttributeString(GetDocumentTag.NAME), STRING_CLASS, true, VariableInfo.AT_END);
         else
            vars[0] = new VariableInfo(data.getAttributeString(GetDocumentTag.NAME), DOCUMENT_CLASS, true, VariableInfo.AT_END);
         return vars;
      }
      else
         return new VariableInfo[0];
   }

   public boolean isValid(TagData data) {
      boolean nameSpec = data.getAttribute(GetDocumentTag.NAME) != null;
      boolean pfxSpec = data.getAttribute(GetDocumentTag.PREFIX) != null;
      boolean textSpec = data.getAttribute(GetDocumentTag.TEXT) != null;
      return !((nameSpec && pfxSpec) || (pfxSpec && textSpec));
   }
}

